import{s as Oe,n as Xe,o as He}from"../chunks/scheduler.7bc62968.js";import{S as Ke,i as Je,g as o,s as n,r as N,A as Ue,h as r,f as a,c as s,j as Be,u as q,x as l,k as Ge,y as Ze,a as i,v as W,d as j,t as V,w as Y}from"../chunks/index.2f8492b0.js";import{H as L}from"../chunks/Heading.14fb2476.js";function Qe(be){let d,O,B,X,m,H,h,Ce="It might be weird that we will explain to you what an image is in a Computer Vision Course. Presumably, you got here in the first place because you wanted to know more about processing image and video formats. It seems trivial, but you are in here for a surprise! When it comes to images, there is much more than meets the eye (pun-intended).",K,c,J,p,Te="An image is a visual representation of an object, a scene, a person, or even a concept. They can be photographs, paintings, drawings, schemes, scans and more! One of the more surprising things is that an image is also a function. More precisely, an image is an n-dimensional function. We will first consider it to be two-dimensional $(n=2)$. We will call it $F(X, Y)$ , where $X$ and $Y$ are spatial coordinates. Do not get distracted by the fancy name. Spatial coordinates are just the system that we use to describe the positions of objects in a physical space with the most common one being the $2D$ Cartesian system. The amplitude of $F$ at a pair of coordinates $(x_i, y_i)$ is the intensity or gray level of the image at that point. The intensity is what gives you the perception of light and dark. Typically, when we have the coordinate pair $x_1$ and $y_1$, we refer to them as pixels (picture elements).",U,f,_e="Images are discrete, and the processes involved in assembling them are continuous. The image generation processes will be discussed in the next chapter. Right now, what matters is that the value of $F$ at specific coordinates holds a physical meaning. The function $F(X, Y)$ is characterized by two components: the amount of illumination from the source and the amount of illumination reflected by the object in the scene. Intensity images are also constrained in their intensity since the function is typically non-negative, and their values are finite.",Z,u,De="That is not the only way one can create an image.  Sometimes, they are created by computers with or without the help of AI.  We have a dedicated chapter for images that do have a little helping hand from AI. Most of the terminology we will introduce here will still be applicable.",Q,g,Ie="A different type of image is volumetric or $3D$ images. The number of dimensions in $3D$ images is equal to three. As a result, we have a $F(X, Y, Z)$ function. Most of our reasoning still applies, with the only difference being that the triplet $x_i, y_i, z_i$ is called a voxel (volume element). These images can be acquired in $3D$; that is, the images are acquired in a way that is reconstructed in a $3D$ space. Examples of such images include medical scans, magnetic resonance, and certain types of microscopes. It is also possible to reconstruct a $3D$ image from a $2D$ one. Reconstructing is a challenging task, and it also has its dedicated chapter.",ee,y,Pe="Now that we have discussed space, we can talk about color. The good news is you have likely heard of image channels, too. You might not understand what they mean, but fear not! Image channels are simply the different color components that make an image. In reference to the $F(X,Y)$, we will have $F$ for each color component. Each color has its own intensity level. For a channel that picks up the color red, a high intensity means that the color is very red and a low intensity means that there is little to no red in there.",te,$,ke="The most common color model is RGB (Red, Green, Blue). Three colors, three channels, three $F(X, Y)$. In this model, the true color of a coordinate $(x_i, y_i)$ is given by the combination of the three different F $(x_i, y_i)$ at that location. Combined, these three colors describe a wide spectrum of colors.",ae,v,Fe="If you’re only looking at the $F(x, y)$ for one color, it ranges from $0$ to $255$, where $0$ represents no intensity and $255$ represents maximum intensity. In a different color system, combining these values might differ. So, it is important to understand where your data comes from when interpretating these values.",ie,x,Se="There are special types of images where the coordinates $x_i, y_i$ do not describe an intensity value, but instead label a pixel. The simplest example of an operation that results in such an image is separating foreground and background. Everything that is foreground receives the label $1$, and everything that is background receives the label $0$. These images are commonly referred to as labeled images. When there are only two labels, like our example, we call them binary images or masks.",ne,w,Ae="You may have heard of $4D$ or even $5D$ images. This terminology is mostly used by people in the biomedical field and microscopists. Again, fear not! This naming came to be from people who image volumetric data in time, with different channels, or different imaging modalities (i.e. photo and an x-ray). The idea is that each new source of information becomes an extra dimension. Thus, a $5D$ image is a volumetric image ($3D$) imaged in time ($4D$) and using different channels ($5D$).",se,b,Me="But how are images represented in computers? Most commonly by matrices. It is easy to picture an image as a $2D$ numerical array. This is an advantage because computers handle arrays really well. Seeing matrices as images helps to understand some of the processes in convolution neural networks and in image preprocessing. We will see more details latter on.",oe,C,Ee="Alternatively, images can be represented as graphs where each node is a coordinate, and the edges are the neighboring coordinates. Take a moment to let that sink in. It also means that the algorithms and models used for graphs can also be used for images! The inverse can also be true - you can transform a graph into an image and analyze it as if it were a picture.",re,T,ze="So far, we proposed a rather flexible definition of an image. This definition can accommodate different ways of acquiring visual data, but they all highlight the same crucial aspect: images are data points that contain a lot of spatial information. The key differences are the spatial resolution (either 2D or 3D), their color systems (RGB or others), and whether they have a time component attached to them.",le,_,de,D,me,I,Re="If you’ve been tuned in,  you may have caught on to the idea that videos are a visual representation of images with a time component attached. For $2D$ image acquisition, you can add a time dimension such that $F(X, Y, T)$ becomes your imaging function.",he,P,Ne="Images can naturally have a hidden component in time. They are, after all, taken at a specific point in time, and different images may be related in time, too. However, images and videos differ in how they sample this temporal information. An image is a static representation at a single point in time, while a video is a sequence of images played at a rate that creates an illusion of motion. This rate is what we can call frames per second.",ce,k,qe="This is so fundamental, that this course has a dedicated chapter to video. There, we will go over the adaptions required to deal with this added dimension.",pe,F,fe,S,We="In tabular data, dimensionality is usually defined by the number of features (columns) describing one data point. In visual data, dimensionality usually refers to the number of dimensions that describe your data. For a $2D$ image, we usually refer to numbers $x_i$ and $y_i$ as the image size.",ue,A,je="Another aspect is the generation of features that describe visual data. They are generated by traditional preprocessing or learned through deep learning methods. We refer to this as feature extraction. It involves different algorithms discussed in more detail in the feature extraction chapter. It contrasts with the feature engineering for tabular data, where new features are built upon existing ones.",ge,M,Ve="Tabular data often require the handling of missing values, encoding categorical variables and re-scaling numerical features. The analogous process for image data is image resizing and intensity value normalization. We call these processes preprocessing and we will discuss them in greater detail in the chapter “preprocessing for computer vision”.",ye,E,$e,z,Ye="The table below summarizes the key aspects of different data types.",ve,R,Le="<thead><tr><th></th> <th>Feature</th> <th>Image</th> <th>Video</th> <th>Audio</th> <th>Tabular Data</th></tr></thead> <tbody><tr><td>1</td> <td>Type</td> <td>Single moment in time</td> <td>Sequence of images over time</td> <td>Single moment in time</td> <td>Structured data organized in rows and columns</td></tr> <tr><td>2</td> <td>Data Representation</td> <td>Typically a 2D array of pixels</td> <td>Typically a 3D array of frames</td> <td>Typically a 1D array of audio samples</td> <td>Typically a 2D array of features as columns and individual data sample as rows (i.e. spreadsheet, database tables</td></tr> <tr><td>3</td> <td>File types</td> <td>JPEG,PNG,RAW, etc.</td> <td>MP4,AVI, MOV, etc.</td> <td>WAV, MP3, FLAC, etc.</td> <td>CSV, Excel (.xlsx, .xls), Database formats, etc.</td></tr> <tr><td>4</td> <td>Data Augmentation</td> <td>Flipping, rotating, cropping</td> <td>Temporal jittering, speed variations, occlusion</td> <td>Background noise addition, reverberation, spectral manipulation</td> <td>ROSE, SMOTE, ADASYN</td></tr> <tr><td>5</td> <td>Feature Extraction</td> <td>Edges, textures, colors</td> <td>Edges, textures, colors, optical flow, trajectories</td> <td>Spectrogram, Mel-Frequency Cepstral Coefficients (MFCCs), Chroma features</td> <td>Statistical analysis, Feature engineering, Data aggregation</td></tr> <tr><td>6</td> <td>Learning Models</td> <td>CNNs</td> <td>RNNs, 3D CNNs</td> <td>CNNs, RNNs</td> <td>Linear Regression, Decision Trees, Random Forests, Gradient Boosting</td></tr> <tr><td>7</td> <td>Machine Learning Tasks</td> <td>Image classification, Segmentation, Object Detection</td> <td>Video action recognition, temporal modeling, tracking</td> <td>Speech recognition, speaker identification, music genre classification</td> <td>Regression, Classification, Clustering</td></tr> <tr><td>8</td> <td>Computational Cost</td> <td>Less expensive</td> <td>More expensive</td> <td>Moderate to high</td> <td>Generally less expensive compared to others</td></tr> <tr><td>9</td> <td>Applications</td> <td>Facial recognition for security access control</td> <td>Sign language interpretation for live communication</td> <td>Voice assistants, Speech-to-text, Music genre classification</td> <td>Predictive modeling, Fraud detection, Weather forecasting</td></tr></tbody>",xe,G,we;return m=new L({props:{title:"Image",local:"image",headingTag:"h1"}}),c=new L({props:{title:"Definition of Image",local:"definition-of-image",headingTag:"h2"}}),_=new L({props:{title:"Images vs Other Data Types",local:"images-vs-other-data-types",headingTag:"h2"}}),D=new L({props:{title:"Difference between Image and Video",local:"difference-between-image-and-video",headingTag:"h3"}}),F=new L({props:{title:"Images vs Tabular Data",local:"images-vs-tabular-data",headingTag:"h3"}}),E=new L({props:{title:"Key Differences",local:"key-differences",headingTag:"h3"}}),{c(){d=o("meta"),O=n(),B=o("p"),X=n(),N(m.$$.fragment),H=n(),h=o("p"),h.textContent=Ce,K=n(),N(c.$$.fragment),J=n(),p=o("p"),p.textContent=Te,U=n(),f=o("p"),f.textContent=_e,Z=n(),u=o("p"),u.textContent=De,Q=n(),g=o("p"),g.textContent=Ie,ee=n(),y=o("p"),y.textContent=Pe,te=n(),$=o("p"),$.textContent=ke,ae=n(),v=o("p"),v.textContent=Fe,ie=n(),x=o("p"),x.textContent=Se,ne=n(),w=o("p"),w.textContent=Ae,se=n(),b=o("p"),b.textContent=Me,oe=n(),C=o("p"),C.textContent=Ee,re=n(),T=o("p"),T.textContent=ze,le=n(),N(_.$$.fragment),de=n(),N(D.$$.fragment),me=n(),I=o("p"),I.textContent=Re,he=n(),P=o("p"),P.textContent=Ne,ce=n(),k=o("p"),k.textContent=qe,pe=n(),N(F.$$.fragment),fe=n(),S=o("p"),S.textContent=We,ue=n(),A=o("p"),A.textContent=je,ge=n(),M=o("p"),M.textContent=Ve,ye=n(),N(E.$$.fragment),$e=n(),z=o("p"),z.textContent=Ye,ve=n(),R=o("table"),R.innerHTML=Le,xe=n(),G=o("p"),this.h()},l(e){const t=Ue("svelte-u9bgzb",document.head);d=r(t,"META",{name:!0,content:!0}),t.forEach(a),O=s(e),B=r(e,"P",{}),Be(B).forEach(a),X=s(e),q(m.$$.fragment,e),H=s(e),h=r(e,"P",{"data-svelte-h":!0}),l(h)!=="svelte-1rwcp0c"&&(h.textContent=Ce),K=s(e),q(c.$$.fragment,e),J=s(e),p=r(e,"P",{"data-svelte-h":!0}),l(p)!=="svelte-saj1wb"&&(p.textContent=Te),U=s(e),f=r(e,"P",{"data-svelte-h":!0}),l(f)!=="svelte-z5nfzw"&&(f.textContent=_e),Z=s(e),u=r(e,"P",{"data-svelte-h":!0}),l(u)!=="svelte-muqstd"&&(u.textContent=De),Q=s(e),g=r(e,"P",{"data-svelte-h":!0}),l(g)!=="svelte-1uvbxun"&&(g.textContent=Ie),ee=s(e),y=r(e,"P",{"data-svelte-h":!0}),l(y)!=="svelte-117rh31"&&(y.textContent=Pe),te=s(e),$=r(e,"P",{"data-svelte-h":!0}),l($)!=="svelte-14bifse"&&($.textContent=ke),ae=s(e),v=r(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-1rndm4d"&&(v.textContent=Fe),ie=s(e),x=r(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-1wd9fxh"&&(x.textContent=Se),ne=s(e),w=r(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-11uk299"&&(w.textContent=Ae),se=s(e),b=r(e,"P",{"data-svelte-h":!0}),l(b)!=="svelte-1vz70h3"&&(b.textContent=Me),oe=s(e),C=r(e,"P",{"data-svelte-h":!0}),l(C)!=="svelte-11l2zjk"&&(C.textContent=Ee),re=s(e),T=r(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-d68vat"&&(T.textContent=ze),le=s(e),q(_.$$.fragment,e),de=s(e),q(D.$$.fragment,e),me=s(e),I=r(e,"P",{"data-svelte-h":!0}),l(I)!=="svelte-1i7wsso"&&(I.textContent=Re),he=s(e),P=r(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-k4vuxa"&&(P.textContent=Ne),ce=s(e),k=r(e,"P",{"data-svelte-h":!0}),l(k)!=="svelte-k7y3fc"&&(k.textContent=qe),pe=s(e),q(F.$$.fragment,e),fe=s(e),S=r(e,"P",{"data-svelte-h":!0}),l(S)!=="svelte-1965a1a"&&(S.textContent=We),ue=s(e),A=r(e,"P",{"data-svelte-h":!0}),l(A)!=="svelte-1nxzgrk"&&(A.textContent=je),ge=s(e),M=r(e,"P",{"data-svelte-h":!0}),l(M)!=="svelte-yhwbee"&&(M.textContent=Ve),ye=s(e),q(E.$$.fragment,e),$e=s(e),z=r(e,"P",{"data-svelte-h":!0}),l(z)!=="svelte-fcbvm6"&&(z.textContent=Ye),ve=s(e),R=r(e,"TABLE",{"data-svelte-h":!0}),l(R)!=="svelte-lkx4v7"&&(R.innerHTML=Le),xe=s(e),G=r(e,"P",{}),Be(G).forEach(a),this.h()},h(){Ge(d,"name","hf:doc:metadata"),Ge(d,"content",et)},m(e,t){Ze(document.head,d),i(e,O,t),i(e,B,t),i(e,X,t),W(m,e,t),i(e,H,t),i(e,h,t),i(e,K,t),W(c,e,t),i(e,J,t),i(e,p,t),i(e,U,t),i(e,f,t),i(e,Z,t),i(e,u,t),i(e,Q,t),i(e,g,t),i(e,ee,t),i(e,y,t),i(e,te,t),i(e,$,t),i(e,ae,t),i(e,v,t),i(e,ie,t),i(e,x,t),i(e,ne,t),i(e,w,t),i(e,se,t),i(e,b,t),i(e,oe,t),i(e,C,t),i(e,re,t),i(e,T,t),i(e,le,t),W(_,e,t),i(e,de,t),W(D,e,t),i(e,me,t),i(e,I,t),i(e,he,t),i(e,P,t),i(e,ce,t),i(e,k,t),i(e,pe,t),W(F,e,t),i(e,fe,t),i(e,S,t),i(e,ue,t),i(e,A,t),i(e,ge,t),i(e,M,t),i(e,ye,t),W(E,e,t),i(e,$e,t),i(e,z,t),i(e,ve,t),i(e,R,t),i(e,xe,t),i(e,G,t),we=!0},p:Xe,i(e){we||(j(m.$$.fragment,e),j(c.$$.fragment,e),j(_.$$.fragment,e),j(D.$$.fragment,e),j(F.$$.fragment,e),j(E.$$.fragment,e),we=!0)},o(e){V(m.$$.fragment,e),V(c.$$.fragment,e),V(_.$$.fragment,e),V(D.$$.fragment,e),V(F.$$.fragment,e),V(E.$$.fragment,e),we=!1},d(e){e&&(a(O),a(B),a(X),a(H),a(h),a(K),a(J),a(p),a(U),a(f),a(Z),a(u),a(Q),a(g),a(ee),a(y),a(te),a($),a(ae),a(v),a(ie),a(x),a(ne),a(w),a(se),a(b),a(oe),a(C),a(re),a(T),a(le),a(de),a(me),a(I),a(he),a(P),a(ce),a(k),a(pe),a(fe),a(S),a(ue),a(A),a(ge),a(M),a(ye),a($e),a(z),a(ve),a(R),a(xe),a(G)),a(d),Y(m,e),Y(c,e),Y(_,e),Y(D,e),Y(F,e),Y(E,e)}}}const et='{"title":"Image","local":"image","sections":[{"title":"Definition of Image","local":"definition-of-image","sections":[],"depth":2},{"title":"Images vs Other Data Types","local":"images-vs-other-data-types","sections":[{"title":"Difference between Image and Video","local":"difference-between-image-and-video","sections":[],"depth":3},{"title":"Images vs Tabular Data","local":"images-vs-tabular-data","sections":[],"depth":3},{"title":"Key Differences","local":"key-differences","sections":[],"depth":3}],"depth":2}],"depth":1}';function tt(be){return He(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class st extends Ke{constructor(d){super(),Je(this,d,tt,Qe,Oe,{})}}export{st as component};
