import{s as ls,n as ms,o as ps}from"../chunks/scheduler.7bc62968.js";import{S as rs,i as cs,g as l,s as e,r as z,m as os,H as hs,A as gs,h as m,f as t,c as i,j as Q,u as j,x as $,n as vs,B as us,k as ns,y as es,a as n,v as L,d as C,t as T,w as k}from"../chunks/index.2f8492b0.js";import{H as P}from"../chunks/Heading.14fb2476.js";function ds(V){let p,H,w,M,r,I,c,q,o,X="Before diving into the different losses used to train models like CLIP, it is important to have a clear understanding of what contrastive learning is. Contrastive Learning is an unsupervised deep learning method aimed at representation learning. Its objective is to develop a data representation where similar items are positioned closely in the representation space and dissimilar items are distinctly separated.",E,h,Y=`In the image below, we have an example where we want to keep the representation from dogs closer to other dogs, but also far from cats.
<img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/contrastive_learning.png" alt="image info"/>`,R,g,A,v,S,u,Z="Contrastive loss is one of the first training objectives used for contrastive learning. It takes a pair of samples as input that can be similar or dissimilar, and the objective is to map similar samples close in the embedding space and push dissimilar samples apart.",U,d,N,B,is='<span class="katex-display"><span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML" display="block"><semantics><mrow><mi>L</mi><mo>=</mo><mn mathvariant="double-struck">1</mn><mo stretchy="false">[</mo><msub><mi>y</mi><mi>i</mi></msub><mo>=</mo><msub><mi>y</mi><mi>j</mi></msub><mo stretchy="false">]</mo><mi mathvariant="normal">∣</mi><mi mathvariant="normal">∣</mi><msub><mi>x</mi><mi>i</mi></msub><mo>−</mo><msub><mi>x</mi><mi>j</mi></msub><mi mathvariant="normal">∣</mi><msup><mi mathvariant="normal">∣</mi><mn>2</mn></msup><mo>+</mo><mn mathvariant="double-struck">1</mn><mo stretchy="false">[</mo><msub><mi>y</mi><mi>i</mi></msub><mo mathvariant="normal">≠</mo><msub><mi>y</mi><mi>j</mi></msub><mo stretchy="false">]</mo><mi>m</mi><mi>a</mi><mi>x</mi><mo stretchy="false">(</mo><mn>0</mn><mo separator="true">,</mo><mi>ϵ</mi><mo>−</mo><mi mathvariant="normal">∣</mi><mi mathvariant="normal">∣</mi><msub><mi>x</mi><mi>i</mi></msub><mo>−</mo><msub><mi>x</mi><mi>j</mi></msub><mi mathvariant="normal">∣</mi><msup><mi mathvariant="normal">∣</mi><mn>2</mn></msup><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">L = \\mathbb{1}[y_i = y_j]||x_i - x_j||^2 + \\mathbb{1}[y_i \\neq y_j]max(0, \\epsilon - ||x_i - x_j||^2)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6833em;"></span><span class="mord mathnormal">L</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord">1</span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">y</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">i</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1.0361em;vertical-align:-0.2861em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">y</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.05724em;">j</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2861em;"><span></span></span></span></span></span></span><span class="mclose">]</span><span class="mord">∣∣</span><span class="mord"><span class="mord mathnormal">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">i</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1.1502em;vertical-align:-0.2861em;"></span><span class="mord"><span class="mord mathnormal">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.05724em;">j</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2861em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord">∣</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8641em;"><span style="top:-3.113em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">2</span></span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord">1</span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">y</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">i</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel"><span class="mrel"><span class="mord vbox"><span class="thinbox"><span class="rlap"><span class="strut" style="height:0.8889em;vertical-align:-0.1944em;"></span><span class="inner"><span class="mord"><span class="mrel"></span></span></span><span class="fix"></span></span></span></span></span><span class="mrel">=</span></span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1.0361em;vertical-align:-0.2861em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">y</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.05724em;">j</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2861em;"><span></span></span></span></span></span></span><span class="mclose">]</span><span class="mord mathnormal">ma</span><span class="mord mathnormal">x</span><span class="mopen">(</span><span class="mord">0</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">ϵ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord">∣∣</span><span class="mord"><span class="mord mathnormal">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">i</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1.1502em;vertical-align:-0.2861em;"></span><span class="mord"><span class="mord mathnormal">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3117em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight" style="margin-right:0.05724em;">j</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2861em;"><span></span></span></span></span></span></span><span class="mord">∣</span><span class="mord"><span class="mord">∣</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8641em;"><span style="top:-3.113em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">2</span></span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span></span>',W,f,ss="Explaining in simple terms:",D,y,as="<li>If the samples are similar ($y_i = y_j$), then we minimize the term $||x_i - x_j||^2$ that corresponds to their Euclidean distance, i.e., we want to make them closer;</li> <li>If the samples are dissimilar ($y_i \\neq y_j$), then we minimize the term $max(0, \\epsilon - ||x_i - x_j||^2)$ that is equivalent to maximizing their euclidean distance until some limit $\\epsilon$, i.e., we want to make them distant from each other.</li>",F,b,G,x,ts='<li><a href="https://www.baeldung.com/cs/contrastive-learning" rel="nofollow">An Introduction to Contrastive Learning</a></li> <li><a href="https://lilianweng.github.io/posts/2021-05-31-contrastive/" rel="nofollow">Contrastive Representation Learning</a></li>',J,_,K;return r=new P({props:{title:"Losses",local:"losses",headingTag:"h1"}}),c=new P({props:{title:"Introduction",local:"introduction",headingTag:"h2"}}),g=new P({props:{title:"Training objectives",local:"training-objectives",headingTag:"h2"}}),v=new P({props:{title:"Constrative Loss",local:"constrative-loss",headingTag:"h3"}}),b=new P({props:{title:"References",local:"references",headingTag:"h2"}}),{c(){p=l("meta"),H=e(),w=l("p"),M=e(),z(r.$$.fragment),I=e(),z(c.$$.fragment),q=e(),o=l("p"),o.textContent=X,E=e(),h=l("p"),h.innerHTML=Y,R=e(),z(g.$$.fragment),A=e(),z(v.$$.fragment),S=e(),u=l("p"),u.textContent=Z,U=e(),d=l("p"),N=os("Technically speaking, imagine that we have a list of input samples ${x_n}$ from multiple classes. We want a function where examples from the same class have their embeddings close in the embedding space, and examples from different classes are far apart. Translating this to a mathematical equation, what we have is:\n"),B=new hs(!1),W=e(),f=l("p"),f.textContent=ss,D=e(),y=l("ul"),y.innerHTML=as,F=e(),z(b.$$.fragment),G=e(),x=l("ul"),x.innerHTML=ts,J=e(),_=l("p"),this.h()},l(s){const a=gs("svelte-u9bgzb",document.head);p=m(a,"META",{name:!0,content:!0}),a.forEach(t),H=i(s),w=m(s,"P",{}),Q(w).forEach(t),M=i(s),j(r.$$.fragment,s),I=i(s),j(c.$$.fragment,s),q=i(s),o=m(s,"P",{"data-svelte-h":!0}),$(o)!=="svelte-1qqkncr"&&(o.textContent=X),E=i(s),h=m(s,"P",{"data-svelte-h":!0}),$(h)!=="svelte-1w6uak4"&&(h.innerHTML=Y),R=i(s),j(g.$$.fragment,s),A=i(s),j(v.$$.fragment,s),S=i(s),u=m(s,"P",{"data-svelte-h":!0}),$(u)!=="svelte-1o0oc7e"&&(u.textContent=Z),U=i(s),d=m(s,"P",{});var O=Q(d);N=vs(O,"Technically speaking, imagine that we have a list of input samples ${x_n}$ from multiple classes. We want a function where examples from the same class have their embeddings close in the embedding space, and examples from different classes are far apart. Translating this to a mathematical equation, what we have is:\n"),B=us(O,!1),O.forEach(t),W=i(s),f=m(s,"P",{"data-svelte-h":!0}),$(f)!=="svelte-1jxjmhl"&&(f.textContent=ss),D=i(s),y=m(s,"UL",{"data-svelte-h":!0}),$(y)!=="svelte-1fzfv5a"&&(y.innerHTML=as),F=i(s),j(b.$$.fragment,s),G=i(s),x=m(s,"UL",{"data-svelte-h":!0}),$(x)!=="svelte-j5koay"&&(x.innerHTML=ts),J=i(s),_=m(s,"P",{}),Q(_).forEach(t),this.h()},h(){ns(p,"name","hf:doc:metadata"),ns(p,"content",fs),B.a=null},m(s,a){es(document.head,p),n(s,H,a),n(s,w,a),n(s,M,a),L(r,s,a),n(s,I,a),L(c,s,a),n(s,q,a),n(s,o,a),n(s,E,a),n(s,h,a),n(s,R,a),L(g,s,a),n(s,A,a),L(v,s,a),n(s,S,a),n(s,u,a),n(s,U,a),n(s,d,a),es(d,N),B.m(is,d),n(s,W,a),n(s,f,a),n(s,D,a),n(s,y,a),n(s,F,a),L(b,s,a),n(s,G,a),n(s,x,a),n(s,J,a),n(s,_,a),K=!0},p:ms,i(s){K||(C(r.$$.fragment,s),C(c.$$.fragment,s),C(g.$$.fragment,s),C(v.$$.fragment,s),C(b.$$.fragment,s),K=!0)},o(s){T(r.$$.fragment,s),T(c.$$.fragment,s),T(g.$$.fragment,s),T(v.$$.fragment,s),T(b.$$.fragment,s),K=!1},d(s){s&&(t(H),t(w),t(M),t(I),t(q),t(o),t(E),t(h),t(R),t(A),t(S),t(u),t(U),t(d),t(W),t(f),t(D),t(y),t(F),t(G),t(x),t(J),t(_)),t(p),k(r,s),k(c,s),k(g,s),k(v,s),k(b,s)}}}const fs='{"title":"Losses","local":"losses","sections":[{"title":"Introduction","local":"introduction","sections":[],"depth":2},{"title":"Training objectives","local":"training-objectives","sections":[{"title":"Constrative Loss","local":"constrative-loss","sections":[],"depth":3}],"depth":2},{"title":"References","local":"references","sections":[],"depth":2}],"depth":1}';function ys(V){return ps(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ws extends rs{constructor(p){super(),cs(this,p,ys,ds,ls,{})}}export{ws as component};
