import{s as xe,n as we,o as be}from"../chunks/scheduler.7bc62968.js";import{S as ye,i as Ce,g as s,s as a,r as I,A as _e,h as r,f as n,c as o,j as ve,u as V,x as l,k as $e,y as Te,a as i,v as z,d as j,t as q,w as E}from"../chunks/index.2f8492b0.js";import{H}from"../chunks/Heading.14fb2476.js";function ke(ae){let m,M,S,U,p,D,f,oe="With the rise of transformers, vision transformers have become essential tools for various computer vision tasks. Vision transformers are great at computer vision tasks involving both images and videos.",F,d,se="However, understanding how these models handle images and videos differently is crucial for optimal performance and accurate results.",L,c,N,h,re=`When it comes to image data, vision transformers typically process individual still images by splitting them into non-overlapping patches and then transforming these patches individually.
Suppose we have a 224x224 image, split the image into 16x16 patches where each patch consists of 14x14 pixels. This patch-based processing not only reduces computation but it also allows the model to capture local features in the image effectively.
Each patch is then fed through a series of self-attention layers and feed-forward neural networks to extract semantic information. Thanks to this hierarchical processing technique, vision transformers are able to capture both high-level and low-level features in the image.
Since vision transformers process patches individually and transformers by default don’t have any mechanism to track position of inputs, the spatial context of the image can be lost.
To address this, vision transformers often include positional encodings that capture the relative position of each patch within the image. By incorporating positional information, the model can better understand the spatial relationships between different patches and enhance its ability to recognize objects and patterns.
<em>Note:</em> CNNs are designed to learn spatial features, while vision transformers are designed to learn both spatial and contextual features.`,A,u,K,g,le="Videos are essentially a sequence of frames, and processing them requires techniques to capture and incorporate motion information. In image processing, the transformer ignores the temporal (time) relations between frames, i.e., it only focuses on a frame’s spatial (space) information.",O,v,me=`Temporal relations are the main factors for developing a strong understanding of content in a video, thus we require a separate algorithm for videos. One of the main differences between image and video processing is the inclusion of an additional axis, time to the input.
There are two main approaches for extracting tokens from a video or embedding a video clip.`,W,$,R,x,pe="It is a straightforward method of tokenizing the input video in which we uniformly sample $$n_t$$ frames from the input video clip, embed each 2D frame independently using the same method as used in image processing, and concatenate all these tokens together.",G,w,fe="If $$n_h<em>n_w$$  non-overlapping image patches are extracted from each frame, then a total of $$n_t</em>n_h*n_w’ tokens will be forwarded through the transformer encoder. Uniform frame sampling is a tokenization scheme in which we sample frames from the video clip and perform simple ViT tokenization.",J,b,Q,y,de="This method extends the vision transformer’s image embedding to 3D and corresponds to a 3D convolution. It is an alternative method in which non-overlapping, spatiotemporal “tubes” from input volume are extracted and linearly projected.",X,C,ce="First, we extract tubes from the video. These tubes contain patches of the frame and the temporal information as well. The tubes are then flattened to build video tokens. Intuitively, this method fuses spatiotemporal information during tokenization, in contrast to “uniform frame sampling”, where temporal information from different frames is fused by the transformer.",Y,_,Z,T,he="The inclusion of temporal information in video processing is crucial for several computer vision tasks. One such task is action recognition, which aims to classify the action in a video. Temporal information is also essential for tasks like video captioning, where the goal is to generate a textual description of the content in a video.",ee,k,ue="By considering the temporal relationships between frames, vision transformers can generate more contextually relevant captions. For example, if a person is shown running in one frame and then jumping in the next, the model can generate a caption that reflects this sequence of action. Furthermore, temporal processing is important for tasks like video object detection and tracking.",te,P,ge="In conclusion, the presence of temporal information and the particular difficulties posed by video data, such as higher memory and storage needs, are the main processing distinctions between video and image. The choice between image and video processing depends on the specific computer vision task and the characteristics of the data.",ne,B,ie;return p=new H({props:{title:"Video Processing Basics",local:"video-processing-basics",headingTag:"h1"}}),c=new H({props:{title:"Understanding Image Processing for Vision Transformers",local:"understanding-image-processing-for-vision-transformers",headingTag:"h2"}}),u=new H({props:{title:"Key Differences Between Image and Video Processing",local:"key-differences-between-image-and-video-processing",headingTag:"h2"}}),$=new H({props:{title:"Uniform Frame Sampling",local:"uniform-frame-sampling",headingTag:"h3"}}),b=new H({props:{title:"Tubelet Embedding",local:"tubelet-embedding",headingTag:"h3"}}),_=new H({props:{title:"Importance of Temporal Information in Video Processing",local:"importance-of-temporal-information-in-video-processing",headingTag:"h2"}}),{c(){m=s("meta"),M=a(),S=s("p"),U=a(),I(p.$$.fragment),D=a(),f=s("p"),f.textContent=oe,F=a(),d=s("p"),d.textContent=se,L=a(),I(c.$$.fragment),N=a(),h=s("p"),h.innerHTML=re,A=a(),I(u.$$.fragment),K=a(),g=s("p"),g.textContent=le,O=a(),v=s("p"),v.textContent=me,W=a(),I($.$$.fragment),R=a(),x=s("p"),x.textContent=pe,G=a(),w=s("p"),w.innerHTML=fe,J=a(),I(b.$$.fragment),Q=a(),y=s("p"),y.textContent=de,X=a(),C=s("p"),C.textContent=ce,Y=a(),I(_.$$.fragment),Z=a(),T=s("p"),T.textContent=he,ee=a(),k=s("p"),k.textContent=ue,te=a(),P=s("p"),P.textContent=ge,ne=a(),B=s("p"),this.h()},l(e){const t=_e("svelte-u9bgzb",document.head);m=r(t,"META",{name:!0,content:!0}),t.forEach(n),M=o(e),S=r(e,"P",{}),ve(S).forEach(n),U=o(e),V(p.$$.fragment,e),D=o(e),f=r(e,"P",{"data-svelte-h":!0}),l(f)!=="svelte-jkpw21"&&(f.textContent=oe),F=o(e),d=r(e,"P",{"data-svelte-h":!0}),l(d)!=="svelte-1pl9bxz"&&(d.textContent=se),L=o(e),V(c.$$.fragment,e),N=o(e),h=r(e,"P",{"data-svelte-h":!0}),l(h)!=="svelte-z4s1nz"&&(h.innerHTML=re),A=o(e),V(u.$$.fragment,e),K=o(e),g=r(e,"P",{"data-svelte-h":!0}),l(g)!=="svelte-1ths8rg"&&(g.textContent=le),O=o(e),v=r(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-1nrnitz"&&(v.textContent=me),W=o(e),V($.$$.fragment,e),R=o(e),x=r(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-yr8mf1"&&(x.textContent=pe),G=o(e),w=r(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-1ulbyyk"&&(w.innerHTML=fe),J=o(e),V(b.$$.fragment,e),Q=o(e),y=r(e,"P",{"data-svelte-h":!0}),l(y)!=="svelte-1knl0u2"&&(y.textContent=de),X=o(e),C=r(e,"P",{"data-svelte-h":!0}),l(C)!=="svelte-jsdyb1"&&(C.textContent=ce),Y=o(e),V(_.$$.fragment,e),Z=o(e),T=r(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-1tnaj0e"&&(T.textContent=he),ee=o(e),k=r(e,"P",{"data-svelte-h":!0}),l(k)!=="svelte-1adu4op"&&(k.textContent=ue),te=o(e),P=r(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-r8xfpe"&&(P.textContent=ge),ne=o(e),B=r(e,"P",{}),ve(B).forEach(n),this.h()},h(){$e(m,"name","hf:doc:metadata"),$e(m,"content",Pe)},m(e,t){Te(document.head,m),i(e,M,t),i(e,S,t),i(e,U,t),z(p,e,t),i(e,D,t),i(e,f,t),i(e,F,t),i(e,d,t),i(e,L,t),z(c,e,t),i(e,N,t),i(e,h,t),i(e,A,t),z(u,e,t),i(e,K,t),i(e,g,t),i(e,O,t),i(e,v,t),i(e,W,t),z($,e,t),i(e,R,t),i(e,x,t),i(e,G,t),i(e,w,t),i(e,J,t),z(b,e,t),i(e,Q,t),i(e,y,t),i(e,X,t),i(e,C,t),i(e,Y,t),z(_,e,t),i(e,Z,t),i(e,T,t),i(e,ee,t),i(e,k,t),i(e,te,t),i(e,P,t),i(e,ne,t),i(e,B,t),ie=!0},p:we,i(e){ie||(j(p.$$.fragment,e),j(c.$$.fragment,e),j(u.$$.fragment,e),j($.$$.fragment,e),j(b.$$.fragment,e),j(_.$$.fragment,e),ie=!0)},o(e){q(p.$$.fragment,e),q(c.$$.fragment,e),q(u.$$.fragment,e),q($.$$.fragment,e),q(b.$$.fragment,e),q(_.$$.fragment,e),ie=!1},d(e){e&&(n(M),n(S),n(U),n(D),n(f),n(F),n(d),n(L),n(N),n(h),n(A),n(K),n(g),n(O),n(v),n(W),n(R),n(x),n(G),n(w),n(J),n(Q),n(y),n(X),n(C),n(Y),n(Z),n(T),n(ee),n(k),n(te),n(P),n(ne),n(B)),n(m),E(p,e),E(c,e),E(u,e),E($,e),E(b,e),E(_,e)}}}const Pe='{"title":"Video Processing Basics","local":"video-processing-basics","sections":[{"title":"Understanding Image Processing for Vision Transformers","local":"understanding-image-processing-for-vision-transformers","sections":[],"depth":2},{"title":"Key Differences Between Image and Video Processing","local":"key-differences-between-image-and-video-processing","sections":[{"title":"Uniform Frame Sampling","local":"uniform-frame-sampling","sections":[],"depth":3},{"title":"Tubelet Embedding","local":"tubelet-embedding","sections":[],"depth":3}],"depth":2},{"title":"Importance of Temporal Information in Video Processing","local":"importance-of-temporal-information-in-video-processing","sections":[],"depth":2}],"depth":1}';function Ie(ae){return be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends ye{constructor(m){super(),Ce(this,m,Ie,ke,xe,{})}}export{qe as component};
