import{s as ye,n as ge,o as ve}from"../chunks/scheduler.7bc62968.js";import{S as be,i as xe,g as s,s as n,r as H,A as ze,h as l,f as i,c as a,j as fe,u as k,x as r,k as we,y as $e,a as o,v as L,d as M,t as I,w as S}from"../chunks/index.2f8492b0.js";import{H as A}from"../chunks/Heading.14fb2476.js";function _e(ie){let m,O,P,j,c,D,d,oe="Have you ever felt confused after the model training stage? What else should you do? If yes, this chapter will help you. In general, the step after we have trained a computer vision model is to deploy it so that other people can use our model. However, when the model has successfully deployed in production, many problems arise, such as the model size being too large, the prediction process taking a long time, and limited memory on the device. These problems can happen because we usually deploy models on devices with smaller specifications than the hardware for training. To overcome the issues, we can carry out additional stages before deploying and model optimization.",U,p,E,u,ne="Model optimization is a process of modifying a model we trained to make it better in terms of efficiency. These modifications are crucial because the hardware we use during training and inference will be very different in most cases. The hardware specifications at the time of inference are smaller, which is why this optimization model needs to be carried out. For example, we have training on high-performance GPUs, and the model inference process will run on edge devices (e.g., microcomputers, mobile devices, IoT, etc.). Of course, these devices have different specifications and tend to be smaller. Carrying out model optimization is crucial so our model can run smoothly on devices with lower specifications.",W,h,G,f,ae="As we already know, optimizing the model is important in before the deployment stage, but why? Several things make this optimization model important to do before the deployment stage. Some of these things are:",K,w,se="<li>Resource limitations: Computer vision models often require high computational resources such as memory, CPU, and GPU. This will be a problem if we want to deploy the model on devices with limited resources, such as mobile phones, embedded systems, or edge devices. Optimization techniques can reduce model size and computational cost and make it deployable for that platform.</li> <li>Latency requirements: Many computer vision applications, such as self-driving cars and augmented reality, require real-time response. This means the model must be able to process data and generate results quickly. Optimization can significantly increase the inference speed of a model and ensure it can meet latency constraints.</li> <li>Power consumption: Devices that use batteries, such as drones and wearable devices, require models with efficient power usage. Optimization techniques can also reduce battery consumption which is often caused by model sizes that are too large.</li> <li>Hardware compatibility: Sometimes, different hardware has its capabilities and limitations. Several optimization techniques are specifically used for specific hardware. If this is done, we can easily overcome the hardware limitations.</li>",R,y,V,g,le="There are several techniques in the model optimization, which will be explained in the next section. However, this section will briefly describe several types:",B,v,re=`<li>Pruning: Pruning is the process of eliminating redundant or unimportant connections in the model. This aims to reduce model size and complexity.
<img src="https://huggingface.co/datasets/hf-vision/course-assets/raw/main/pruning.png" alt="Pruning"/></li> <li>Quantization: Quantization means converting model weights from high-precision formats (e.g., 32-bit floating-point) to lower-precision formats (e.g., 16-bit floating-point or 8-bit integers) to reduce memory footprint and increase inference speed.</li> <li>Knowledge Distillation: Knowledge distillation aims to transfer knowledge from a complex and larger model (teacher model) to a smaller model (student model) by mimicking the behavior of the teacher model.
<img src="https://huggingface.co/datasets/hf-vision/course-assets/raw/main/knowledge_distillation.png" alt="Knowledge Distillation"/></li> <li>Low-rank approximation: Approximates large matrices with small ones, reducing memory consumption and computational costs.</li> <li>Model compression with hardware accelerators: This process is like pruning and quantization. But, running on specific hardware such as NVIDIA GPUs and Intel Hardware.</li>`,F,b,Q,x,me="A trade-off exists between accuracy, performance, and resource usage when deploying a model. That’s when we have to decide which part to prioritize so that the model can be maximized in the case at hand.",N,z,ce="<li>Accuracy is the model’s ability to predict correctly. High accuracy is needed in all applications, which also causes higher performance and resource usage. Complex models with high accuracy usually require a lot of memory, so there will be limitations if they are deployed on resource-constrained devices. Complex models with high accuracy usually require a lot of memory, so there will be limitations if they are deployed on resource-constrained devices.</li> <li>Performance is the model’s speed and efficiency (latency). This is important so the model can make predictions quickly, even in real time. However, optimizing performance will usually result in decreasing accuracy.</li> <li>Resource usage is the computational resources needed to perform inference on the model, such as CPU, memory, and storage. Efficient resource usage is crucial if we want to deploy models on devices with certain limitations, such as smartphones or IoT devices.</li>",J,$,de="Image below shows a common computer vision model in terms of model size, accuracy, and latency. Bigger model has high accuracy, but needs more time for inference and big size.",X,_,pe='<img src="https://huggingface.co/datasets/hf-vision/course-assets/raw/main/model_size_vs_accuracy.png" alt="Model Size VS Accuracy"/>',Y,C,ue='<img src="https://huggingface.co/datasets/hf-vision/course-assets/raw/main/accuracy_vs_latency.png" alt="Accuracy VS Latency"/>',Z,T,he="These are the three things we must consider: where do we focus on the model we trained? For example, focusing on high accuracy will result in a slower model during inference or require extensive resources. To overcome this, we apply one of the optimization methods as explained so that the model we get can maximize or balance the trade-off between the three components mentioned above.",ee,q,te;return c=new A({props:{title:"Introduction to model optimization for deployment",local:"introduction-to-model-optimization-for-deployment",headingTag:"h1"}}),p=new A({props:{title:"What is model optimization?",local:"what-is-model-optimization",headingTag:"h2"}}),h=new A({props:{title:"Why is it important for deployment in computer vision?",local:"why-is-it-important-for-deployment-in-computer-vision",headingTag:"h2"}}),y=new A({props:{title:"Different types of model optimization techniques",local:"different-types-of-model-optimization-techniques",headingTag:"h2"}}),b=new A({props:{title:"Trade-offs between accuracy, performance, and resource usage",local:"trade-offs-between-accuracy-performance-and-resource-usage",headingTag:"h2"}}),{c(){m=s("meta"),O=n(),P=s("p"),j=n(),H(c.$$.fragment),D=n(),d=s("p"),d.textContent=oe,U=n(),H(p.$$.fragment),E=n(),u=s("p"),u.textContent=ne,W=n(),H(h.$$.fragment),G=n(),f=s("p"),f.textContent=ae,K=n(),w=s("ol"),w.innerHTML=se,R=n(),H(y.$$.fragment),V=n(),g=s("p"),g.textContent=le,B=n(),v=s("ol"),v.innerHTML=re,F=n(),H(b.$$.fragment),Q=n(),x=s("p"),x.textContent=me,N=n(),z=s("ol"),z.innerHTML=ce,J=n(),$=s("p"),$.textContent=de,X=n(),_=s("p"),_.innerHTML=pe,Y=n(),C=s("p"),C.innerHTML=ue,Z=n(),T=s("p"),T.textContent=he,ee=n(),q=s("p"),this.h()},l(e){const t=ze("svelte-u9bgzb",document.head);m=l(t,"META",{name:!0,content:!0}),t.forEach(i),O=a(e),P=l(e,"P",{}),fe(P).forEach(i),j=a(e),k(c.$$.fragment,e),D=a(e),d=l(e,"P",{"data-svelte-h":!0}),r(d)!=="svelte-xlukum"&&(d.textContent=oe),U=a(e),k(p.$$.fragment,e),E=a(e),u=l(e,"P",{"data-svelte-h":!0}),r(u)!=="svelte-anjnz9"&&(u.textContent=ne),W=a(e),k(h.$$.fragment,e),G=a(e),f=l(e,"P",{"data-svelte-h":!0}),r(f)!=="svelte-z5ucfa"&&(f.textContent=ae),K=a(e),w=l(e,"OL",{"data-svelte-h":!0}),r(w)!=="svelte-wjwe0m"&&(w.innerHTML=se),R=a(e),k(y.$$.fragment,e),V=a(e),g=l(e,"P",{"data-svelte-h":!0}),r(g)!=="svelte-1c7g3k3"&&(g.textContent=le),B=a(e),v=l(e,"OL",{"data-svelte-h":!0}),r(v)!=="svelte-16ka7ye"&&(v.innerHTML=re),F=a(e),k(b.$$.fragment,e),Q=a(e),x=l(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1a584pj"&&(x.textContent=me),N=a(e),z=l(e,"OL",{"data-svelte-h":!0}),r(z)!=="svelte-1mfj83s"&&(z.innerHTML=ce),J=a(e),$=l(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-11usv4t"&&($.textContent=de),X=a(e),_=l(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-nbqdvf"&&(_.innerHTML=pe),Y=a(e),C=l(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-10upufk"&&(C.innerHTML=ue),Z=a(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-hj2tz9"&&(T.textContent=he),ee=a(e),q=l(e,"P",{}),fe(q).forEach(i),this.h()},h(){we(m,"name","hf:doc:metadata"),we(m,"content",Ce)},m(e,t){$e(document.head,m),o(e,O,t),o(e,P,t),o(e,j,t),L(c,e,t),o(e,D,t),o(e,d,t),o(e,U,t),L(p,e,t),o(e,E,t),o(e,u,t),o(e,W,t),L(h,e,t),o(e,G,t),o(e,f,t),o(e,K,t),o(e,w,t),o(e,R,t),L(y,e,t),o(e,V,t),o(e,g,t),o(e,B,t),o(e,v,t),o(e,F,t),L(b,e,t),o(e,Q,t),o(e,x,t),o(e,N,t),o(e,z,t),o(e,J,t),o(e,$,t),o(e,X,t),o(e,_,t),o(e,Y,t),o(e,C,t),o(e,Z,t),o(e,T,t),o(e,ee,t),o(e,q,t),te=!0},p:ge,i(e){te||(M(c.$$.fragment,e),M(p.$$.fragment,e),M(h.$$.fragment,e),M(y.$$.fragment,e),M(b.$$.fragment,e),te=!0)},o(e){I(c.$$.fragment,e),I(p.$$.fragment,e),I(h.$$.fragment,e),I(y.$$.fragment,e),I(b.$$.fragment,e),te=!1},d(e){e&&(i(O),i(P),i(j),i(D),i(d),i(U),i(E),i(u),i(W),i(G),i(f),i(K),i(w),i(R),i(V),i(g),i(B),i(v),i(F),i(Q),i(x),i(N),i(z),i(J),i($),i(X),i(_),i(Y),i(C),i(Z),i(T),i(ee),i(q)),i(m),S(c,e),S(p,e),S(h,e),S(y,e),S(b,e)}}}const Ce='{"title":"Introduction to model optimization for deployment","local":"introduction-to-model-optimization-for-deployment","sections":[{"title":"What is model optimization?","local":"what-is-model-optimization","sections":[],"depth":2},{"title":"Why is it important for deployment in computer vision?","local":"why-is-it-important-for-deployment-in-computer-vision","sections":[],"depth":2},{"title":"Different types of model optimization techniques","local":"different-types-of-model-optimization-techniques","sections":[],"depth":2},{"title":"Trade-offs between accuracy, performance, and resource usage","local":"trade-offs-between-accuracy-performance-and-resource-usage","sections":[],"depth":2}],"depth":1}';function Te(ie){return ve(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ke extends be{constructor(m){super(),xe(this,m,Te,_e,ye,{})}}export{ke as component};
